#!/usr/bin/perl
# get.cgi : iContact T[o (ContactXML t@CpT[o)
# version: 0.61
use Socket;

%form = &read_params();
&get_document($form{"url"});

#####################################################
sub get_document {
    my($url) = @_;
    my($host,$port) = &get_host_and_port($url);

    $sockaddr='S n a4 x8';
    $local_prot=(getprotobyname('tcp'))[2];
    $remote_sock=pack($sockaddr,AF_INET,$port,(gethostbyname($host))[4]);

    socket(S,PF_INET,SOCK_STREAM,$local_prot) || &err("$0: socket: $!\n");
    connect(S,$remote_sock) || &err("$0: cannot connect to $host\n");

    $_=select(S); $|=1; select($_);

    print S "GET $url HTTP/1.0\r\n";
    print S "User-Agent: get.cgi (iContact Server)\r\n";
    print S "Accept: */*\r\n";
    print S "\r\n";
    # headers
    # ignore status header
    <S>;
    @headers = ();
    while (<S>) {
	last if (/^\r\n$/);
	# ignore Content-Type header if not image.
	if (/^content-type:\s*(.*)/i) {
	    $line = $_;
	    $_ = $1;
	    if (/^image\/.*/i) {
		push(@headers, $line);
	    } elsif (/^text\/xml/i || /^application\/xml/i) {
		push(@headers, "Content-Type: application/octet-stream\r\n");
	    } else {
		&err("invalid media type");
	    }
	} else {
	    push(@headers, $_);
	}
    }
    print @headers;
    print "\r\n";
    while(<S>){
	print;
    }
    close(S);
}    

sub get_host_and_port {
    ($_) = @_;
    my ($prot, $host_and_port) = /^([^:]+):\/\/([^\/]+)/;;
    die if($prot ne "http");
    my ($host, $port) = split(":", $host_and_port);
    $port = ($port eq "") ? 80 : int($port);
    ($host, $port);
}

sub read_params
{
    my ($buffer, @pairs, $pair, $name, $value, %FORM);
    $ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
    if ($ENV{'REQUEST_METHOD'} eq "POST") {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    } else {
        $buffer = $ENV{'QUERY_STRING'};
    }
    @pairs = split(/&/, $buffer);
    foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ s/\+/ /g;
        $value =~ s/%(..)/pack("C", hex($1))/eg;
        $FORM{$name} = $value;
    }
    %FORM;
}

sub err
{
    print "Content-Type: text/plain\r\n";
    print "\r\n";
    print "@_\n";
    exit;
}
